<master>
<property name="doc(title)">@page_title;literal@</property>
<property name="main_navbar_label">timesheet2_timesheet</property>
<property name="left_navbar">@left_navbar_html;literal@</property>


<div id=@task_editor_id@>
<script type='text/javascript' <if @::__csp_nonce@ not nil>nonce="@::__csp_nonce;literal@"</if>>


// Ext.Loader.setConfig({enabled: true});
Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('PO.model', '/sencha-core/model');
Ext.Loader.setPath('PO.store', '/sencha-core/store');
Ext.Loader.setPath('PO.class', '/sencha-core/class');
Ext.Loader.setPath('Ext.ux', '/sencha-core/ux');
Ext.Loader.setPath('PO.view', '/sencha-core/view');
Ext.Loader.setPath('PO.controller', '/sencha-core/controller');

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'PO.Utilities',
    'PO.store.CategoryStore',
    'PO.store.project.ProjectMainStore',
    'PO.controller.StoreLoadCoordinator',
    'PO.model.timesheet.TimesheetTask',
    'PO.model.timesheet.Hour',
    'PO.model.project.Project',
    'PO.store.timesheet.HourStore',
    'PO.store.timesheet.TaskTreeStore',
    'PO.view.field.POComboTree'
]);

// Global parameters from server-side
var default_material_id = parseInt('@default_material_id@');			// "Default" material
var default_cost_center_id = parseInt('@default_cost_center_id@');		// "The Company" cost-center
var default_uom_id = parseInt('@default_uom_id@');				// "Hour" default Unit of Measure
var default_effort_driven_type_id = parseInt('@default_effort_driven_type_id@'); // "Fixed Effort" as default


function launchTimesheetWeeklyLogging(){

    // -----------------------------------------------------------------------
    // Stores
    var hourStore = Ext.StoreManager.get('hourStore');
    var taskTreeStore = Ext.StoreManager.get('taskTreeStore');
    var projectStore = Ext.StoreManager.get('projectMainStore');

    // -----------------------------------------------------------------------
    // Renderer to display a project_id as project_name
    var hourGridProjectRenderer = function(project_id, metaData, record, rowIndex, colIndex, store, view) {
        var projectName = '#'+project_id;
        var projectNode = taskTreeStore.getNodeById(project_id);
        if (projectNode) { projectName = projectNode.get('project_name'); }
        return projectName;
    };

    var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
        clicksToMoveEditor: 2,
        listeners: {
            edit: function(editor, context, eOpts) {
                // Check that the endTime is later than startTime
                context.record.save();
            }
        }
    });

    // !!!
    var hourGrid = Ext.create('Ext.grid.Panel', {
        store: hourStore,
        layout: 'fit',
        region: 'center',
        plugins: [rowEditing],
        columns: [
	    {
                text: 'Project',
                flex: 1,
                dataIndex: 'main_project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
		    var main_project_id = record.get('main_project_id');
                    var projectModel = projectStore.getById(main_project_id);
                    if (!projectModel) return "";
                    return projectModel.get('project_name');
                },
		editor: { xtype: 'combo', queryMode: 'local', store: projectStore, displayField: 'project_name', valueField: 'project_id', matchFieldWidth: false }
            }, {
                text: 'Task',
                flex: 1,
                dataIndex: 'project_id',
                renderer: function(task_id) {
                    var taskModel = taskTreeStore.getById(task_id);
                    if (!taskModel) return "";
                    return taskModel.get('project_name');
                },
		editor: { xtype: 'pocombotree', store: taskTreeStore, queryMode: 'local', displayField: 'project_name', valueField: 'id'}
            }, {
		text: "Date",
		xtype: 'datecolumn',
		dataIndex: 'day', 
		renderer: Ext.util.Format.dateRenderer('Y-m-d'),
		editor: {
                    xtype: 'datefield',
                    allowBlank: true,
                    startDay: @week_start_day@
		}
            }, {
		text: "Hours", flex: 1, dataIndex: 'hours', editor: { xtype: 'numberfield', minValue: 0 }
            }, {
		text: "Note", flex: 1, dataIndex: 'note',
		editor: { allowBlank: true }
            }],
        columnLines: true,
        enableLocking: true,
        collapsible: false,
        title: 'Expander Rows in a Collapsible Grid with lockable columns',
        header: false,
        emptyText: 'No data yet - please click on one of the tasks at the left',
        iconCls: 'icon-grid',
        margin: '0 0 20 0'
    });

    // -----------------------------------------------------------------------
    // Outer panel joining the two parts (Buttons + Grid)
    var screenSize = Ext.getBody().getViewSize();    // Size calculation based on specific ]po[ layout
    var sideBarSize = Ext.get('sidebar').getSize();
    var width = screenSize.width - sideBarSize.width - 95;
    var height = screenSize.height - 280;

    Ext.define('PO.view.timesheet.HourWeeklyButtonPanel', {
        extend: 'Ext.panel.Panel',
        alias: 'ganttButtonPanel',
        width: 900,
        height: 500,
        layout: 'border',
        defaults: {
            collapsible: true,
            split: true,
            bodyPadding: 0
        },
        tbar: [
            {
                icon: '/intranet/images/navbar_default/add.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Manual_logging "Manual logging"] %>',
                id: 'buttonAddEntry',
                disabled: false
            }, {
                icon: '/intranet/images/navbar_default/delete.png',
                tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Delete_logging "Delete entry"] %>',
                id: 'buttonDeleteEntry',
                disabled: false
            }
        ]
    });

    // Use the button panel as a container for the task tree and the hour grid
    var hourButtonPanel = Ext.create('PO.view.timesheet.HourWeeklyButtonPanel', {
        renderTo: '@task_editor_id@',
        width: width,
        height: height,
        resizable: true,					// Add handles to the panel, so the user can change size
        items: [
            hourGrid
        ]
    });

    // -----------------------------------------------------------------------
    // Controller for interaction between Tree and Grid
    //
    Ext.define('PO.controller.timesheet.HourWeeklyController', {
        extend: 'Ext.app.Controller',

        // Variables
        debug: true,

        'selectedTask': null,					// Task selected by selection model
        'loggingTask': null,					// contains the task on which hours are logged or null otherwise
        'loggingStartDate': null,				// contains the time when "start" was pressed or null otherwise
        'loggingInterval': null,				// the hour object created when logging

        // Parameters
        'renderDiv': null,
        'hourButtonPanel': null,
        'hourController': null,
        'hourGrid': null,

        // Setup the various listeners so that everything gets concentrated here on
        // this controller.
        init: function() {
            var me = this;
            if (me.debug) { console.log('PO.controller.timesheet.HourWeeklyController: init'); }

            this.control({
                '#buttonAddEntry': { click: this.onButtonAddEntry },
                '#buttonDeleteEntry': { click: this.onButtonDeleteEntry },
                scope: me
            });

            // Listen to the Grid Editor that allows to specify start- and end time
            me.hourGrid.on('edit', this.onGridEdit, me);
            me.hourGrid.on('beforeedit', this.onGridBeforeEdit, me);

            // Catch a global key strokes. This is used to abort entry with Esc.
            // For some reaons this doesn't work on the level of the HourButtonPanel, so we go for the global "window"
            Ext.EventManager.on(window, 'keydown', this.onWindowKeyDown, me);

            return this;
        },


        /*
         * The user has double-clicked on the row editor in order to
         * manually fill in the values. This procedure automatically
         * fills in the end_time.
         */
        onGridBeforeEdit: function(editor, context, eOpts) {
            console.log('GanttButtonController.onGridBeforeEdit');
            console.log(context.record);

            var endTime = context.record.get('interval_end_time');
            if (typeof endTime === 'undefined' || "" == endTime) {
                endTime = /\d\d:\d\d/.exec(""+new Date())[0];
                context.record.set('interval_end_time', endTime);
            }
            // Return true to indicate to the editor that it's OK to edit
            return true;
        },

        // 
        onGridEdit: function(editor, context) {
            console.log('GanttButtonController.onGridEdit');
            var rec = context.record;
            
            var interval_date = rec.get('interval_date');
            var interval_start = rec.get('interval_start');
            var interval_start_time = rec.get('interval_start_time');
            var interval_end = rec.get('interval_end');
            var interval_end_time = rec.get('interval_end_time');
            if ("" == interval_start_time) { interval_start_time = null; }
            if ("" == interval_end_time) { interval_end_time = null; }

            // start == end => Delete the entry
            if (interval_start_time != null && interval_end_time != null) {
                if (interval_start_time == interval_end_time) {
                    rec.destroy();
                    return;
                }
            }

            if (interval_date != null) {
                // The interval_date has been overwritten by the editor with a Date
                var value = new Date(interval_date);
                rec.set('interval_date', Ext.Date.format(value, 'Y-m-d'));
            }

            if (interval_date != null && interval_start_time != null) {
                var value = new Date(interval_date);
                value.setHours(interval_start_time.substring(0,2));
                value.setMinutes(interval_start_time.substring(3,5));
                rec.set('interval_start', Ext.Date.format(value, 'Y-m-d H:i:s'));
            }

            if (interval_date != null && interval_end_time != null) {
                var value = new Date(interval_date);
                value.setHours(interval_end_time.substring(0,2));
                value.setMinutes(interval_end_time.substring(3,5));
                rec.set('interval_end', Ext.Date.format(value, 'Y-m-d H:i:s'));
            }

            rec.save();
            rec.commit();

        },

        // Esc (Escape) button pressed somewhere in the application window
        onWindowKeyDown: function(e) {
            var keyCode = e.getKey();
            var keyCtrl = e.ctrlKey;
            console.log('GanttButtonController.onWindowKeyDown: code='+keyCode+', ctrl='+keyCtrl);
            
            // cancel hour logging with Esc key
            if (27 == keyCode) { this.onButtonCancelLogging(); }
            if (46 == keyCode) { this.onButtonDeleteEntry(); }
        },

        // Click into the empty space below the grid entries in order to start creating a new entry
        onGridContainerClick: function() {
            console.log('GanttButtonController.GridContainerClick');
            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var disabled = buttonStartLogging.disabled;
            if (!disabled) {
                this.onButtonStartLogging();
            }
        },

        /*
         * Start logging the time.
         * Before calling this procedure, the user must have selected a single
         * leaf in the task tree for logging hours.
         */
        onButtonStartLogging: function() {
            console.log('GanttButtonController.ButtonStartLogging');

        },

        /*
         * Start logging the time, for entirely manual entries.
         */
        onButtonAddEntry: function() {
            console.log('GanttButtonController.ButtonManualLogging');

            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            buttonAddEntry.disable();
            buttonDeleteEntry.enable();
            rowEditing.cancelEdit();

	    // !!!
            var day = PO.Utilities.dateToPg(new Date());
            var hour = new Ext.create('PO.model.timesheet.Hour', {
                user_id: @current_user_id@,
		// project_id: @project_id@,
                day: day
            });

            hourStore.add(hour);
            rowEditing.startEdit(hour, 0);
        },

        onButtonStopLogging: function() {
            console.log('GanttButtonController.ButtonStopLogging');
            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var buttonStopLogging = Ext.getCmp('buttonStopLogging');
            var buttonCancelLogging = Ext.getCmp('buttonCancelLogging');
            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            buttonStartLogging.enable();
            buttonStopLogging.disable();
            buttonCancelLogging.disable();
            buttonAddEntry.enable();

            // Complete the hour created when starting to log
            this.loggingInterval.set('interval_end_time', /\d\d:\d\d/.exec(""+new Date())[0]);

            // Not necesary anymore because the store is set to autosync?
            this.loggingInterval.save();
            rowEditing.cancelEdit();

            // Stop logging
            this.loggingTask = null;
            this.loggingStartDate = null;

            // Continue editing the task
            var rowIndex = hourStore.count() -1;
            rowEditing.startEdit(rowIndex, 3);
        },

        onButtonCancelLogging: function() {
            console.log('GanttButtonController.ButtonCancelLogging');
            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var buttonStopLogging = Ext.getCmp('buttonStopLogging');
            var buttonCancelLogging = Ext.getCmp('buttonCancelLogging');
            var buttonAddEntry = Ext.getCmp('buttonAddEntry');

            buttonStartLogging.enable();
            buttonStopLogging.disable();
            buttonCancelLogging.disable();
            buttonAddEntry.enable();

            // Check if a leaf is selected in order to determine if StartLogging can be enabled
            var isLeaf = this.ganttTreePanelLeafSelected();
            buttonStartLogging.setDisabled(!isLeaf);
            buttonAddEntry.setDisabled(!isLeaf);
            
            // Delete the started line
            rowEditing.cancelEdit();
            hourStore.remove(this.loggingInterval);

            // Stop logging
            this.loggingTask = null;
            this.loggingStartDate = null;
        },

        onButtonDeleteEntry: function() {
	    var me = this;
            console.log('GanttButtonController.ButtonDeleteLogging');

            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            // var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            buttonAddEntry.enable();
            // buttonDeleteEntry.enable();
            rowEditing.cancelEdit();

	    var records = hourGrid.getSelectionModel().getSelection();
            // Not logging already - enable the "start" button
            if (1 == records.length) {                  // Exactly one record enabled
                var record = records[0];
                hourStore.remove(record);
                record.destroy();
            }	    
        },

        /**
         * Control the enabled/disabled status of the Start/Stop logging buttons.
         * Skip logging hours when changing the selection.
         */
        onTreePanelSelectionChange: function(view, records) {
            if (this.debug) { console.log('GanttButtonController.onTreePanelSelectionChange'); }
            // Skip changes on the selection model while logging hours
            if (this.loggingTask) { 
                console.log('GanttButtonController.onTreePanelSelectionChange: While logging hours - skip logging');
                this.onButtonCancelLogging();
                return; 
            }
            var buttonStartLogging = Ext.getCmp('buttonStartLogging');
            var buttonAddEntry = Ext.getCmp('buttonAddEntry');
            // Not logging already - enable the "start" button
            if (1 == records.length) {					// Exactly one record enabled
                selectedTask = records[0];				// Remember which task is selected
                var isLeaf = selectedTask.isLeaf();
                buttonStartLogging.setDisabled(!isLeaf);
                buttonAddEntry.setDisabled(!isLeaf);

                // load the list of hours into the hourGrid
                var projectId = selectedTask.get('id');
                hourStore.getProxy().extraParams = { 
                    query: 'project_id in (select p.project_id from im_projects p, im_projects main_p where main_p.project_id = '+projectId+' and p.tree_sortkey between main_p.tree_sortkey and tree_right(main_p.tree_sortkey))',
                    user_id: @current_user_id@, 
                    format: 'json' 
                };

                hourStore.load({
                    callback: function() {
                        console.log('PO.store.timesheet.HourWeeklyStore: loaded');
                    }
                });
            } else {							// Zero or two or more records enabled
                buttonStartLogging.setDisabled(true);
                buttonAddEntry.setDisabled(true);
            }                
        },

        /**
         * Clicking around in the grid part of the screen,
         * Enable or disable the "Delete" button
         */
        onGridSelectionChange: function(view, records) {
            if (this.debug) { console.log('GanttButtonController.onGridSelectionChange'); }
            var buttonDeleteEntry = Ext.getCmp('buttonDeleteEntry');
            buttonDeleteEntry.setDisabled(1 != records.length);
        },


        /**
         * Handle various key actions
         */
        onCellKeyDown: function(table, htmlTd, cellIndex, record, htmlTr, rowIndex, e, eOpts) {
            console.log('GanttButtonController.onCellKeyDown');
            var keyCode = e.getKey();
            var keyCtrl = e.ctrlKey;
            console.log('GanttButtonController.onCellKeyDown: code='+keyCode+', ctrl='+keyCtrl);
        },


        /**
         * The windows as a whole was resized
         */
        onWindowsResize: function(width, height) {
            console.log('GanttButtonController.onWindowResize');
            var me = this;
            var sideBar = Ext.get('sidebar');				// ]po[ left side bar component
            var sideBarSize = sideBar.getSize();
            me.onResize(sideBarSize.width);
        },

        /**
         * The ]po[ left sideBar was resized
         */
        onSideBarResize: function(event, el, config) {
            console.log('GanttButtonController.onSideBarResize');
            var me = this;
            var sideBar = Ext.get('sidebar');				// ]po[ left side bar component
            var sideBarSize = sideBar.getSize();

            // We get the event _before_ the sideBar has changed it's size.
            // So we actually need to the the oposite of the sidebar size:
            if (sideBarSize.width > 100) {
                sideBarSize.width = -5;
            } else {
                sideBarSize.width = 245;
            }

            me.onResize(sideBarSize.width);
        },

        /**
         * Generic resizing function, called with the target width of the sideBar
         */
        onResize: function(sideBarWidth) {
            console.log('GanttButtonController.onResize: '+sideBarWidth);
            var me = this;
            var screenSize = Ext.getBody().getViewSize();
            var height = me.hourButtonPanel.getSize().height;
            var width = screenSize.width - sideBarWidth - 75;
            me.hourButtonPanel.setSize(width, height);
        }
        
    });


    var sideBarTab = Ext.get('sideBarTab');
    var hourController = Ext.create('PO.controller.timesheet.HourWeeklyController', {
        'hourButtonPanel': hourButtonPanel,
        'hourController': hourController,
        'hourGrid': hourGrid
    });
    hourController.init(this).onLaunch(this);

    // Testing events
    hourButtonPanel.fireEvent('keypress');



    // -----------------------------------------------------------------------
    // Handle collapsable side menu
    sideBarTab.on('click', hourController.onSideBarResize, hourController);
    Ext.EventManager.onWindowResize(hourController.onWindowsResize, hourController);    // Deal with resizing the main window

};


var debugHash = @debug_json;noquote@;
function getDebug(id) {
    // Check for a debug setting for the specific Id
    var debug = parseInt(debugHash[id]);
    if (!isNaN(debug)) return debug;

    // Use the default debug
    debug = parseInt(debugHash['default']);
    if (!isNaN(debug)) return debug;

    // invalid configuration - enable debug
    return 1;
};

// -----------------------------------------------------------------------
// Start the application after loading the necessary stores
//
Ext.onReady(function() {
    Ext.QuickTips.init();
    var debug = getDebug('default');
    var taskTreeStore = Ext.create('PO.store.timesheet.TaskTreeStore');
    var hourStore = Ext.create('PO.store.timesheet.HourStore');
    var projectStore = Ext.create('PO.store.project.ProjectMainStore');

    // Use a "store coodinator" in order to launchTimesheetWeeklyLogging() only
    // if all stores have been loaded:
    var coordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        stores: [
            'hourStore', 
            'taskTreeStore',
	    'projectMainStore'
        ],
        listeners: {
            load: function() {
                if ("boolean" == typeof this.loadedP) { return; }
                launchTimesheetWeeklyLogging();
                this.loadedP = true;
            }
        }
    });

    // Load stores that need parameters
    taskTreeStore.getProxy().extraParams = { project_id: @project_id@ };
    taskTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');

            if (!success) {
                PO.Utilities.reportStoreError("TaskTreeStore", operation);
                return;
            }

            var mainProjectNode = records[0];
            mainProjectNode.set('sort_order','0');
            me.setRootNode(mainProjectNode);
        }
    });

    // Load stores that need parameters
    hourStore.getProxy().extraParams = { project_id: @project_id@, user_id: @current_user_id@, format: 'json' };
    hourStore.load({
        callback: function() {
            console.log('PO.store.timesheet.HourStore: loaded');
        }
    });

    // Load stores that need parameters
    projectStore.getProxy().extraParams = { query: 'parent_id is NULL and project_status_id = 76', format: 'json' };
    projectStore.load({
        callback: function() {
            console.log('PO.store.project.ProjectMainStore: loaded');
        }
    });




});
</script>
</div>


